chiark / gitweb /
el/dot-emacs.el: Basic configuration (and fixes) for Magit's repo list.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile lesskey sqliterc
137   parallel-config:.parallel/config
138   ipython_config.py:.ipython/profile_default/ipython_config.py
139   ditz-config
140   mailrc signature muttrc
141   cgrc tigrc
142   gdbinit
143   guile
144   rcrc
145   toprc
146   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
147   pulse-daemon.conf:.pulse/daemon.conf
148   aspell.conf
149   tclshrc:.tclshrc tclshrc:.wishrc
150   lisp-init.lisp:.cmucl-init.lisp
151     lisp-init.lisp:.sbclrc
152     lisp-init.lisp:.clisprc.lisp
153     lisp-init.lisp:.eclrc
154   swank.lisp
155   mdw-build.conf:.config/mdw-build.conf
156   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
157   dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
158 [ "$xstuff" ] && dotfiles="$dotfiles
159   xinitrc xsession xmodmap vncrc vncsession
160   fonts.conf
161   stalonetrayrc
162   putty-defaults:.putty/sessions/Default%20Settings
163   mdw.session:.config/gnome-session/sessions/mdw.session
164   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
165   e-keybindings.cfg:.enlightenment/keybindings.cfg
166   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
167   e16-bindings:.e16/bindings.cfg
168   gtkrc-2.0
169   gtk3.css:.config/gtk-3.0/gtk.css
170   gtk3-settings.ini:.config/gtk-3.0/settings.ini"
171 echo "Installing dotfiles..."
172 for d in $dotfiles; do
173   target=.$d
174   case $d in
175     *:*) target=${d#*:} d=${d%%:*};;
176   esac
177   ft=$HOME$sub/$target
178   dir=${ft%/*}
179   mkdir -p $dir
180   ln -s $here/dot/$d $ft.new
181   mv $ft.new $ft
182   echo "  $target"
183 done
184 echo "  all done."
185
186 ## CPP-hack files which need it.
187 cppfiles=""
188 [ "$xstuff" ] && cppfiles="$cppfiles
189   Xdefaults"
190 echo "Hacking files with C preprocessor..."
191 defs="-DHOME=$HOME -DPROFILE=$here"
192 defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
193 for c in $cppfiles; do
194   target=.$c
195   case $c in
196     *:*) target=${c#*:} c=${c%%:*};;
197   esac
198   ft=$HOME$sub/$target
199   dir=${ft%/*}
200   mkdir -p $dir
201   cpp -P $defs dot/$c -o $ft.new
202   mv $ft.new $ft
203   echo "  $target"
204 done
205 echo "  all done."
206
207 ## Substitute things which need substituting.
208 dotfilessubst="
209   gitconfig
210   mykermrc
211   pulse-default.pa.in:.pulse/default.pa"
212 echo "Installing dotfiles with substitutions..."
213 for d in $dotfilessubst; do
214   case $d in
215     *:*) target=${d#*:} d=${d%%:*};;
216     *) target=.$d d=$d.in;;
217   esac
218   ft=$HOME$sub/$target
219   dir=${ft%/*}
220   mkdir -p $dir
221   sed "
222 1i\\
223 ### generated by $here/setup; do not edit!\\
224
225 /@home@/ s\a\a$HOME\ag
226 /@profile@/ s\a\a$here\ag
227 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
228 " dot/$d >$ft.new
229   mv $ft.new $ft
230   echo "  $target"
231 done
232 echo "  all done."
233
234 ## Symlink backgrounds.
235 backgrounds=$(cd bg && echo *)
236 if [ "$xstuff" ]; then
237   echo "Installing backgrounds..."
238   for b in $backgrounds; do
239     for e in enlightenment e16; do
240       dir=$HOME$sub/.$e/backgrounds
241       t=$dir/$b
242       mkdir -p $dir
243       ln -s $here/bg/$b $t.new
244       mv $t.new $t
245     done
246     echo "  $b"
247   done
248   echo "        all done."
249 fi
250
251 ###--------------------------------------------------------------------------
252 ### Install useful scripts included in this package.
253
254 scripts="
255   mdw-editor
256   mdw-pager
257   mdw-conf
258   mdw-build mdw-sbuild mdw-sbuild-server
259   update-buildable-branch
260   emacsclient-hack
261   movemail-hack
262   sendmail-hack
263   aspell-hack
264   emerge-hack
265   lesspipe.sh
266   run-with-shell-env
267   start-ssh-agent
268   start-ssh-pageant
269   svnwrap
270   guest-console
271   hyperspec"
272 [ "$xstuff" ] && scripts="$scripts
273   xinitcmd
274   un-backslashify-selection
275   lock-screen
276   xpra-start-xdummy
277   xshutdown"
278 echo "Installing scripts..."
279 mkdir -p $HOME$sub/bin
280 for s in $scripts; do
281   ft=$HOME$sub/bin/$s
282   ln -s $here/bin/$s $ft.new
283   mv $ft.new $ft
284   echo "  $s"
285 done
286 echo "  all done."
287
288 hacks="
289   ssh:ssh"
290 echo "Installing hacks..."
291 for h in $hacks; do
292   d=${h%%:*} h=${h#*:}
293   ft=$HOME$sub/bin/hacks/$d
294   mkdir -p $ft
295   ln -s $here/hacks/$h $ft/$h.new
296   mv $ft/$h.new $ft/$h
297   echo "  $d:$h"
298 done
299 echo "  all done."
300
301 ###--------------------------------------------------------------------------
302 ### Set up the Emacs config.
303
304 $echon "Finding a suitable emacs:$echoc"
305 emacs=no
306 for i in emacs24 emacs23 emacs22 emacs21 emacs; do
307   if type -p >/dev/null $i; then
308     emacs=$i
309     break
310   fi
311 done
312 if [ $emacs = no ]; then
313   echo " failed."
314   emacs=:
315 else
316   echo " $emacs."
317 fi
318
319 echo "Installing Emacs packages..."
320 emacspkg="
321   make-regexp
322   ew-hols
323   mdw-gnus-patch
324   git git-blame vc-git stgit
325   mdw-multiple-cursors
326   quilt"
327 for elib in $emacspkg; do
328   $echon "  $elib:$echoc"
329   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
330        (progn
331          (setq load-path (nconc load-path (list "~/lib/emacs")))
332          (kill-emacs (condition-case nil
333                          (progn (load-library "'"$elib"'") 0)
334                        (error 1))))'; then
335     echo " already installed."
336   else
337     if [ -f el/$elib.el ]; then
338       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
339     else
340       $echon " downloading$echoc"
341       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
342     fi
343     $echon " compiling$echoc"
344     (cd $HOME$sub/lib/emacs;
345       $emacs >/dev/null 2>&1 --no-site-file --batch \
346         --eval '(byte-compile-file "'"$elib.el"'")')
347     echo " done."
348   fi
349 done
350 echo "  all done."
351
352 $echon "Setting up Emacs configuration:$echoc"
353 $echon " linking$echoc"
354 for f in dot-emacs.el Makefile; do
355   set -- $(echo $link | tr : ' ')
356   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
357   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
358 done
359 $echon " compiling$echoc"
360 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
361 echo " done."
362
363 ###----- That's all, folks --------------------------------------------------